#include <iostream>
#include <math.h>
#include <cmath>

using namespace std;

long long cbrt(long long c) {
    long long l = 0, r = 1e+6 + 1;
    while (r - l > 1) {
        long long m = (r + l) / 2;
        if (m * m * m > c) {
            r = m;
        } else {
            l = m;
        }
    }
    /*if (l * l * l < c) {
        return r;
    }*/
    return l;
}

long long a, b, k;
long long start, finish;

long long upsqrt(long long c) {
    long long sq = sqrt(c);
    if (sq * sq < c) {
        ++sq;
    }
    return sq;
}

long long formatrt(long long c, long long center) {
//    cout << "[format " << c << ' ' << center << ' ' << (long long)sqrt(c) * (long long)sqrt(c) + k << ']' << ' ';
    if (center - k > c && (long long)sqrt(c) * (long long)sqrt(c) + k < center) {
        return (long long)sqrt(c) + 1;
    }
    return sqrt(c);
}

int main() {
    cin >> a >> b >> k;
    start = cbrt(a);
    finish = cbrt(b);
    long long ans = 0;
//    cout << start << ".." << finish << endl;
    for (long long i = start; i <= finish; ++i) {
        long long i3 = i * i * i;
        long long rightb = min(i3 + k, b);
        long long leftb = max(i3 - k, a);
//        cout << "for i = " << i << " i3 = " << i3 << "; " << leftb << ' ' << rightb << " => " << upsqrt(leftb) << ' ' << (long long)sqrt(rightb) << endl;
        if (rightb >= leftb) ans += (long long)sqrt(rightb) - upsqrt(leftb) + 1;
        //cout << "step " << i << endl;
    }
    cout << ans << endl;
    return 0;
}

/*
1000000 1000000 1000000000
1 1000000000000000000 0
1000000000 1000000000 0
1000000000 1000014129 14128
999985871 1000000000 14129
*/
