#include <iostream>
#include <math.h>
#include <cmath>

using namespace std;

long long cbrt(long long c) {
    long long l = 0, r = 1e+6 + 1;
    while (r - l > 1) {
        long long m = (r + l) / 2;
        if (m * m * m > c) {
            r = m;
        } else {
            l = m;
        }
    }
    if (l * l * l < c) {
        return r;
    }
    return l;
}

long long upsqrt(long long c) {
    long long sq = sqrt(c);
    if (sq * sq < c) {
        ++sq;
    }
    return sq;
}

int main() {
    long long a, b, k;
    cin >> a >> b >> k;
    long long start = cbrt(a);
    long long finish = cbrt(b);
    long long ans = 0;
//    cout << "start" << finish << "\n";
//    for (long long i = start; i <= sqrt(b); ++i) {
//        for (long long j = start; j <= sqrt(b); ++j) {
//            if (abs(j * j * j - i * i) <= k && j * j * j <= b && i * i <= b && i * i >= a && j * j * j >= a) {
////                cout << i << ' ' << j << endl;
//                ++ans;
//            }
//        }
//    }
//    cout << ans << endl;
//    ans = 0;
    for (long long i = start; i <= finish; ++i) {
        long long i3 = i * i * i;
        long long rightb = min(i3 + k, b);
        long long leftb = max(i3 - k, a);
//        cout << "for i = " << i << " i3 = " << i3 << ' ' << leftb << ' ' << rightb << " => " << (long long)upsqrt(leftb) << ' ' << (long long)sqrt(rightb) << endl;
        if (rightb >= leftb) ans += (long long)sqrt(rightb) - (long long)upsqrt(leftb) + 1;
        //cout << "step " << i << endl;
    }
    cout << ans << endl;
    return 0;
}

/*
1000000 1000000 1000000000
1 1000000000000000000 0
*/
