#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>

using namespace std;

struct men {
    int number;
    int time;
    int floor;
    int status = 0;
    /// 0 - not queue
    /// 1 - wait
    /// 2 - in lift
    /// 3 - on 1 floor
    int outtime = 0;
};

bool cmp(const men &a, const men &b) {
    if (a.time == b.time) {
        return a.number < b.number;
    }
    return a.time < b.time;
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<men> people(n);
    for (int i = 0; i < n; ++i) {
        cin >> people[i].time >> people[i].floor;
        people[i].number = i;
    }
    sort(people.begin(), people.end(), cmp);
    int globaltime = 0;
    int floor = 1;
    int activecall = 1;
    int outed = n;
    int next = 0;
    int liftstate = 0;
    /// 0 - on 1 floor
    /// 1 - move up
    /// 2 - move down
    vector<vector<int>> floors(m + 1, vector<int>(0));
    queue<int> calls;
    vector<int> answer(n, 0);
    while (outed > 0) {
        if (liftstate == 0) {
//            cout << "state 0, time " << globaltime << "\n";
            globaltime = people[next].time;
//            cout << "globaltime updated " << globaltime  << endl;
            floors[people[next].floor].push_back(people[next].number);
            liftstate = 1;
            activecall = people[next].floor;
            ++next;
        }
        if (liftstate == 1) {
//            cout << "state 1, activecall " << activecall << endl;
            globaltime += activecall - 1;
            while (next < n && people[next].time <= globaltime) {
                floors[people[next].floor].push_back(people[next].number);
//                cout << "people " << people[next].number << "called\n";
                if (people[next].floor != activecall) {
                    calls.push(people[next].floor);
                }
                ++next;
            }
//            cout << "updated new calls\n";
            for (int i = 0; i < floors[activecall].size(); ++i) {
                answer[floors[activecall][i]] = globaltime + activecall - 1;
                --outed;
            }
//            cout << "answers calculated\n";
            floors[activecall].resize(0);
            floor = activecall;
//            cout << "begin movedown\n";
            liftstate = 2;
        }
        if (liftstate == 2) {
            while (floor != 1) {
                --floor;
                ++globaltime;
                while (next < n && people[next].time == globaltime) {
                    floors[people[next].floor].push_back(people[next].number);
                    calls.push(people[next].floor);
                    ++next;
                }
                if (floors[floor].size() > 0) {
                    for (int i = 0; i < floors[floor].size(); ++i) {
                        answer[floors[floor][i]] = globaltime + floor - 1;
                        --outed;
                    }
                    floors[floor].resize(0);
                }
            }
            liftstate = 3;
        }
        if (liftstate == 3) {
            while (!calls.empty() && floors[calls.front()].empty()) {
                calls.pop();
            }
            if (calls.empty()) {
                liftstate = 0;
            } else {
                activecall = calls.front();
                calls.pop();
                liftstate = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << answer[i] << endl;
    }
//    map<int, queue<int>> qf;
//
//    while (outed > 0) {
//        if (activecall == 1) {
//            globaltime = people[next].time;
//            qf[people[next].floor].push(people[next].number);
//            activecall = people[next].floor;
//            ++next;
//            liftstate = 1;
//        } else {
//            priority_queue<int> floors;
//            if (liftstate == 1) {
//                while (people[next].time <= globaltime + activecall - 1) {
//                    qf[people[next].floor].push(people[next].number);
//                    ++next;
//                }
//                globaltime += activecall - 1;
//                while (!qf[activecall].empty()) {
//                    answer[qf[activecall].front()] = globaltime + activecall - 1;
//                    qf[activecall].pop();
//                    --n;
//                }
//                liftstate = 2;
//            }
//            if (liftstate == 2) {
//                activecall =
//                while (floor[activecall])
//            }
//        }
//    }
    return 0;
}

/*
5 4
2 3
2 4
5 2
5 3
9 3

10 100
100 5
104 2
103 20
104 20
105 20
104 40
400 21
405 22
406 23
407 8

10 100
10 100
11 99
12 98
13 98
14 97
15 21
15 21
16 23
17 52
108 61
*/
